#pragma once

/* The Hercules VIM requires IRQ handler addresses to be 4-byte aligned, even
 * if they are thumb-encoded. (The least-significant 2 bits are ignored.) */
#define RT_VIC_IRQ_ALIGN 4

/* The SSI should be routed to channel 126, which is the lowest priority.
 * This maps to bit 30 of the REQENA*3 registers.
 * Note: this is not the SSI's default VIM channel. */
#ifndef RT_VIM_SSI_CHANNEL
#define RT_VIM_SSI_CHANNEL 126
#endif

#ifndef __ASSEMBLER__

#define SYS_SSIR1 (*(volatile uint32_t *)0xFFFFFFB0U)
#define SYS_SSIR1_KEY (UINT32_C(0x75) << 8)

static inline void vic_syscall_pend(void)
{
    SYS_SSIR1 = SYS_SSIR1_KEY;
}

#endif
