#pragma once

#include <rt/arch/profile.h>

#ifdef __ARM_FP
#define RT_ARM_FP 1
#else
#define RT_ARM_FP 0
#endif

#ifdef __ARM_NEON
#define RT_ARM_NEON 1
#else
#define RT_ARM_NEON 0
#endif

#ifndef RT_ARM_FP_D32
/* If not explicitly defined, assume that there are 32 double-precision
 * registers in A-profile or if Neon is enabled. */
#define RT_ARM_FP_D32 (RT_ARM_PROFILE_A || RT_ARM_NEON)
#endif

#define RT_FPEXC_EN (UINT32_C(1) << 30)

#ifndef __ASSEMBLER__

#include <stdbool.h>

bool rt_lazy_enable_fp(void);

#endif // __ASSEMBLER__
