#pragma once

@ vim:ft=arm

#include <rt/arch/profile.h>

.macro mov32 reg, imm
#if RT_ARM_V6M
    ldr \reg, =\imm
#else // !RT_ARM_V6M
    movw \reg, :lower16:\imm
    movt \reg, :upper16:\imm
#endif // RT_ARM_V6M
.endm

#if !defined(__thumb__) || RT_ARM_V6M
// arm mode and v6m don't have cbz/cbnz, so make our own.
.macro cbz reg, label
    cmp \reg, 0
    beq \label
.endm

.macro cbnz reg, label
    cmp \reg, 0
    bne \label
.endm
#endif // !defined(__thumb__) || RT_ARM_V6M
