#pragma once

#include <rt/arch/profile.h>

#if RT_ARM_PROFILE_AR

void rt_svc_handler(void);

/* When hardware-vectored IRQs are enabled, this handler should be installed to
 * handle the IRQ triggered by rt_syscall_pend(). */
void rt_syscall_irq_handler(void);

/* When hardware-vectored IRQs are not enabled, this should be used as the
 * top-level IRQ handler. */
void rt_irq_handler(void);

/* When hardware-vectored IRQs are not enabled, this handler should be used as
 * the handler for the interrupt triggered by rt_syscall_pend(). It is called
 * as a normal function from rt_irq_handler. */
void rt_syscall_handler(void);

#elif RT_ARM_PROFILE_M

void rt_svcall_handler(void);

void rt_pendsv_handler(void);

#endif
