#pragma once

#include <rt/arch/profile.h>

#if RT_ARM_V8M

// non-secure stack, thread mode, no FP, use PSP, non-secure exception
#define TASK_INITIAL_EXC_RETURN 0xFFFFFFBC

// Provide the negative of this for v8m.base.
#define TASK_INITIAL_EXC_RETURN_NEG 68

#else // !RT_ARM_V8M (v6m or v7m)

// thread mode, no FP, use PSP
#define TASK_INITIAL_EXC_RETURN 0xFFFFFFFD

// Provide the negative of this for v6m.
#define TASK_INITIAL_EXC_RETURN_NEG 3

#endif // RT_ARM_V8M
