#include "water.hpp"

#include <rt/barrier.hpp>
#include <rt/sem.hpp>

class reaction
{
  public:
    reaction() : h(rt::sem(2)), o(rt::sem(1)), barrier(rt::barrier(3))
    {
    }

    void hydrogen()
    {
        h.wait();
        barrier.wait();
        barrier.wait();
        h.post();
    }

    void oxygen()
    {
        o.wait();
        barrier.wait();
        make_water();
        barrier.wait();
        o.post();
    }

  private:
    rt::sem h, o;
    rt::barrier barrier;
};

static reaction rxn;

void hydrogen()
{
    rxn.hydrogen();
}

void oxygen()
{
    rxn.oxygen();
}
