#include "water.hpp"

#include <rt/cond.hpp>
#include <rt/mutex.hpp>

class reaction
{
  public:
    reaction() : h(0)
    {
    }

    void hydrogen()
    {
        rt::lock_guard lock(m);
        ++h;
        hready.signal();
        hdone.wait(m);
    }

    void oxygen()
    {
        {
            rt::lock_guard lock(m);
            while (h < 2)
            {
                hready.wait(m);
            }
            make_water();
            h -= 2;
        }
        hdone.signal();
        hdone.signal();
    }

  private:
    int h;
    rt::cond hready, hdone;
    rt::mutex m;
};

static reaction rxn;

void hydrogen()
{
    rxn.hydrogen();
}

void oxygen()
{
    rxn.oxygen();
}
