#include "water.hpp"

#include <rt/sem.hpp>

class reaction
{
  public:
    reaction() : h(0)
    {
    }

    void hydrogen()
    {
        unsigned oldh = rt_atomic_fetch_add(&h, 1, RT_ATOMIC_RELAXED);
        if ((oldh & 1) == 1)
        {
            h2ready.post();
        }
        hdone.wait();
    }

    void oxygen()
    {
        h2ready.wait();
        make_water();
        hdone.post(2);
    }

  private:
    rt::sem h2ready, hdone;
    rt_atomic_uint h;
};

static reaction rxn;

void hydrogen()
{
    rxn.hydrogen();
}

void oxygen()
{
    rxn.oxygen();
}
