#pragma once

#include <rt/barrier.h>

namespace rt
{

class barrier
{
  public:
    constexpr barrier(unsigned int count) noexcept
        : b(RT_BARRIER_INIT(b, count))
    {
    }

    bool wait() noexcept
    {
        return rt_barrier_wait(&this->b);
    }

    barrier(const barrier &) = delete;
    barrier(const barrier &&) = delete;
    barrier &operator=(const barrier &) = delete;
    barrier &operator=(const barrier &&) = delete;

  private:
    struct rt_barrier b;
};

} // namespace rt
