#pragma once

#include <rt/cond.h>

#include <rt/mutex.hpp>

namespace rt
{

class cond
{
  public:
    constexpr cond() noexcept : c(RT_COND_INIT(c))
    {
    }

    void signal() noexcept
    {
        rt_cond_signal(&this->c);
    }

    void broadcast() noexcept
    {
        rt_cond_broadcast(&this->c);
    }

    void wait(mutex &m) noexcept
    {
        return rt_cond_wait(&this->c, &m.m);
    }

    bool timedwait(mutex &m, unsigned long ticks) noexcept
    {
        return rt_cond_timedwait(&this->c, &m.m, ticks);
    }

    cond(const cond &) = delete;
    cond(const cond &&) = delete;
    cond &operator=(const cond &) = delete;
    cond &operator=(const cond &&) = delete;

  private:
    struct rt_cond c;
};

} // namespace rt
