#pragma once

#include <rt/once.h>

namespace rt
{

class once
{
  public:
    constexpr once() noexcept : o(RT_ONCE_INIT(o))
    {
    }

    void call(void (*fn)(void)) noexcept
    {
        rt_once_call(&this->o, fn);
    }

    once(const once &) = delete;
    once(const once &&) = delete;
    once &operator=(const once &) = delete;
    once &operator=(const once &&) = delete;

  private:
    struct rt_once o;
};

} // namespace rt
