#pragma once

#include <rt/task.h>

namespace rt
{

namespace task
{

static inline const char *name() noexcept
{
    return rt_task_name();
}

static inline void yield() noexcept
{
    rt_task_yield();
}

static inline void sleep(unsigned long ticks) noexcept
{
    rt_task_sleep(ticks);
}

static inline void sleep_periodic(unsigned long &last_wake_tick,
                                  unsigned long period) noexcept
{
    rt_task_sleep_periodic(&last_wake_tick, period);
}

[[noreturn]] static inline void exit() noexcept
{
    rt_task_exit();
}

static inline void drop_privilege() noexcept
{
    rt_task_drop_privilege();
}

} // namespace task

} // namespace rt
