#include <rt/cycle.h>
#include <rt/log.h>
#include <rt/mutex.h>
#include <rt/task.h>
#include <rt/trap.h>

#define N 100

static volatile uint32_t start_cycle = 0;
static volatile uint32_t cycles[N];

static RT_MUTEX(mutex);

static void task0(void)
{
    for (int i = 0; i < N; ++i)
    {
        rt_mutex_lock(&mutex);
        rt_task_sleep(2);
        start_cycle = rt_cycle();
        rt_mutex_unlock(&mutex);
    }
}

static void task1(void)
{
    for (int i = 0; i < N; ++i)
    {
        rt_task_sleep(1);
        rt_mutex_lock(&mutex);
        cycles[i] = rt_cycle() - start_cycle;
        rt_mutex_unlock(&mutex);
    }
    rt_trap();
}

RT_TASK(task0, RT_STACK_MIN, 1);
RT_TASK(task1, RT_STACK_MIN, 0);
