#include <rt/cycle.h>
#include <rt/log.h>
#include <rt/notify.h>
#include <rt/task.h>
#include <rt/trap.h>

#define N 100

static volatile uint32_t start_cycle = 0;
static volatile uint32_t cycles[N];

static RT_NOTIFY(note, 0);

static void poster(void)
{
    for (int i = 0; i < N; ++i)
    {
        start_cycle = rt_cycle();
        rt_notify_post(&note);
    }
}

static void waiter(void)
{
    for (int i = 0; i < N; ++i)
    {
        rt_notify_wait(&note);
        cycles[i] = rt_cycle() - start_cycle;
    }
    rt_trap();
}

RT_TASK(poster, RT_STACK_MIN, 1);
RT_TASK(waiter, RT_STACK_MIN, 0);
