#include <rt/cycle.h>
#include <rt/log.h>
#include <rt/task.h>
#include <rt/trap.h>

#define N 100

static volatile uint32_t start_cycle = 0;
static volatile uint32_t cycles[N];

static void sleep(void)
{
    for (int i = 0; i < N; ++i)
    {
        start_cycle = rt_cycle();
        rt_task_sleep(1);
    }
}

static void task1(void)
{
    for (int i = 0; i < N; ++i)
    {
        cycles[i] = rt_cycle() - start_cycle;
        rt_task_sleep(1);
    }
    rt_trap();
}

RT_TASK(sleep, RT_STACK_MIN, 0);
RT_TASK(task1, RT_STACK_MIN, 1);
