#include <rt/assert.h>
#include <rt/sem.h>
#include <rt/task.h>
#include <rt/trap.h>

static const int n = 10;
static RT_SEM(sem, 0);

static void poster(void)
{
    rt_task_drop_privilege();
    for (int i = 0; i < n; ++i)
    {
        rt_task_sleep(5);
        rt_sem_post(&sem);
    }

    rt_task_sleep(15);
    rt_sem_post(&sem);
}

static void waiter(void)
{
    rt_task_drop_privilege();
    for (int i = 0; i < n; ++i)
    {
        rt_assert(rt_sem_timedwait(&sem, 10), "wait timed out");
    }

    rt_assert(!rt_sem_timedwait(&sem, 10), "wait didn't time out");

    rt_trap();
}

RT_TASK(poster, RT_STACK_MIN, 0);
RT_TASK(waiter, RT_STACK_MIN, 0);
