#include <rt/task.h>
#include <rt/tls.h>
#include <rt/trap.h>

#include <stdint.h>

static _Thread_local uint32_t x;
static _Thread_local uint32_t y = 2;

static void task0(void)
{
    x = 1;
    for (;;)
    {
        x += 2;
        rt_task_yield();
        y += x;
        rt_assert((x & 1) == 1, "x has an unexpected value");
    }
}

static void task1(void)
{
    x = 0;
    for (;;)
    {
        x += 2;
        rt_task_yield();
        y += x;
        rt_assert((x & 1) == 0, "x has an unexpected value");
        rt_assert((x & 1) == 0, "y has an unexpected value");
    }
}

static void timeout(void)
{
    rt_task_drop_privilege();
    rt_task_sleep(1000);
    rt_trap();
}

RT_TASK(task0, RT_STACK_MIN, 1);
RT_TASK(task1, RT_STACK_MIN, 1);
RT_TASK(timeout, RT_STACK_MIN, 0);
