#!/bin/bash

set -xe

name="rt-rust"
image="$name-builder"

rust_dir="$(dirname $0)"
rt_dir="$(realpath "$rust_dir"/..)"

docker build --tag "$image" "$rust_dir"

home_dir="/home/rt"

docker run \
  --rm \
  --tty \
  --interactive \
  --volume "$rt_dir:$home_dir" \
  --workdir "$home_dir" \
  --cap-add SYS_PTRACE \
  "$image"
