#![no_main]

use core::sync::atomic::{AtomicU32, Ordering};

rt::mutex!(H, u32, 0);
rt::condvar!(HREADY);
rt::condvar!(HDONE);

fn hydrogen() {
    let mut g = H.lock();
    *g += 1;
    HREADY.signal();
    HDONE.wait(&g);
}

fn oxygen() {
    let mut g = H.lock();
    HREADY.wait_while(&g, |&h| h < 2);
    make_water();
    *g -= 2;
    g.unlock();
    HDONE.signal();
    HDONE.signal();
}

include!("water.rs");
