#![cfg_attr(not(test), no_std)]

pub mod cycle;
pub mod sync;
pub mod task;
pub mod tick;

mod bindings;
mod list;

pub fn trap() -> ! {
    unsafe { bindings::rt_trap() }
}

/* The paste macro must be re-exported so rt's macros can use it without
 * other crates directly using paste. */
#[doc(hidden)]
pub use paste;

#[cfg(test)]
fn test_init() {
    use std::sync::Once;

    static TEST_INIT: Once = Once::new();
    TEST_INIT.call_once(|| unsafe {
        bindings::rt_start_context();
    });
}
