#!/bin/bash

set -e

scons -j $(nproc)

trap 'if [ "$?" != "0" ]; then echo "test failed!"; fi' EXIT

examples=(
  donate empty float mutex notify once queue rwlock sem simple
  water/barrier water/cond water/sem cycle/mutex cycle/notify cycle/queue
  cycle/sem cycle/sleep cycle/yield cxx/mutex cxx/notify cxx/once cxx/queue
  cxx/rwlock cxx/sem cxx/water/barrier cxx/water/cond cxx/water/sem
)

for e in "${examples[@]}"; do
  echo "running $e..."
  "build/$e" &
done

wait

# run the sleep examples one-by-one as they are performance-sensitive
# (threads getting delayed will fail an assert)

sleep_examples=(
  sleep cxx/sleep
)

for e in "${sleep_examples[@]}"; do
  echo "running $e..."
  "build/$e"
done
